<script setup lang="ts">
import { storeToRefs } from 'pinia'
import { useAccountStore } from '~~/store/account'
import { useCallStore } from '~~/store/call'
import { useZoomStore } from '~~/store/zoom'
import { useZoomClientStore } from '~~/store/zoomClient'

const account = useAccountStore()
const { full } = storeToRefs(account)
const call = useCallStore()
const zoom = useZoomStore()
const zoomClient = useZoomClientStore()
const questionModal = ref(false)

const createMeetingClient = () => {
  zoomClient.startClient()
  zoom.$patch({ model: false })
  zoomClient.clientWindow = true
}
const model = ref(false)
const joinZoom = (id: string) => {
  call.currentIndex = id
  zoom.$patch({ model: false })
  if (full.value) {
    zoomClient.clientWindow = true
    zoomClient.joinClient()
    return
  }
  questionModal.value = true
}
const accept = () => {
  zoomClient.clientWindow = true
  zoomClient.joinClient()
}
const remove = () => {
  call.currentIndex = ''
  zoom.$patch({ model: true })
}
</script>

<template>
  <OQuestionModal v-if="questionModal" @accept="() => questionModal = false" />
  <div
    class="z-50 fixed top-0 w-screen h-screen bg-image flex flex-col justify-center items-center text-2xl transition-all duration-500 text-white"
    :class="[zoom.model ? 'left-0' : 'left-full']"
  >
    <div v-if="call.loadingState">
      <h1 class="text-3xl mb-5">
        新規作成
      </h1>
    </div>
    <div v-else-if="account.availableMeeting.length > 0" class="flex flex-col items-center">
      <h1 class="text-3xl mb-5">
        利用可能な会議のリスト
      </h1>
      <div class="flex gap-2 flex-row lt-sm:flex-col justitfy-center items-center">
        <MMeetingInfo
          v-for="meeting in account.availableMeeting"
          :key="meeting.id"
          :data="meeting"
          @click="() => joinZoom(meeting.id)"
        />
      </div>
    </div>
    <div v-else>
      <h1 class="text-3xl mb-5">
        開催しているミーティングがありません
      </h1>
    </div>
    <div v-if="call.availableIndex.length > 0 && account.joinCode === 1">
      <button
        class="rounded-md bg-blue-800/30 cursor-pointer py-2 px-4 border-2 border-blue-300 mt-10"
        @click="createMeetingClient"
      >
        ここをクリックしてミーティングを作成する
      </button>
      <button
        class="rounded-md bg-blue-800/30 cursor-pointer py-2 px-4 border-2 border-blue-300 mt-10"
        @click="model = true"
      >
        会議を設定する
      </button>
    </div>
    <OSchedule
      v-if="model"
      class="top-1/2 left-1/2 translate-x--1/2 translate-y--1/2 absolute max-w-95% fixed"
      @exit="model = false"
    />
  </div>
</template>

<style scoped></style>

<route lang="yaml"></route>
